#include <stdlib.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/*
** Depth Peeling Υ쥤䡼
*/
static int layer = 0;

/*
** 
*/
static const GLfloat lightpos[] = { 4.0, 9.0, 5.0, 1.0 }; /* ֡ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ľܸ١ */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* Ķ١ */

/*
** ƥ
*/
#define TEXWIDTH  512                                     /* ƥ */
#define TEXHEIGHT 512                                     /* ƥι⤵ */

/*
** 
*/
static void init(void)
{
  /* ƥγơݤΥƥΥǥץХåեȤƻȤ */
  glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, TEXWIDTH, TEXHEIGHT, 0,
    GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, 0);
  
  /* ƥ硦̾ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  
  /* ƥη֤ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);

  /* 񤭹ݥꥴΥƥɸͤΣҤȥƥȤӤԤ褦ˤ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE, GL_COMPARE_R_TO_TEXTURE);
  
  /* ⤷ҤͤƥͤĶƤ鿿ʥե饰Ȥ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_FUNC, GL_GREATER);
  
  /* Ӥη̤򥢥եͤȤ */
  glTexParameteri(GL_TEXTURE_2D, GL_DEPTH_TEXTURE_MODE, GL_ALPHA);
  
  /* եƥȤӴؿʤ͡ */
  glAlphaFunc(GL_GEQUAL, 0.5f);

  /* ƥɸ˻ɸϤˤʪΤκɸͤѤ */
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
  glTexGeni(GL_Q, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);

  /* ƥɸ򤽤Τޤ (S, T, R, Q) ˻Ȥ */
  static const GLdouble genfunc[][4] = {
    { 1.0, 0.0, 0.0, 0.0 },
    { 0.0, 1.0, 0.0, 0.0 },
    { 0.0, 0.0, 1.0, 0.0 },
    { 0.0, 0.0, 0.0, 1.0 },
  };
  glTexGendv(GL_S, GL_EYE_PLANE, genfunc[0]);
  glTexGendv(GL_T, GL_EYE_PLANE, genfunc[1]);
  glTexGendv(GL_R, GL_EYE_PLANE, genfunc[2]);
  glTexGendv(GL_Q, GL_EYE_PLANE, genfunc[3]);

  /*  */
  glClearColor(0.3f, 0.3f, 1.0f, 1.0f);
  glEnable(GL_DEPTH_TEST);
  
  /* ν */
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightamb);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcol);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightcol);

  /* Polygon Offset  */
  glPolygonOffset(1.0f, 1.0f);
}


/****************************
** GLUT ΥХåؿ **
****************************/

/* ȥåܡѴؿ */
#include "trackball.h"

/* ؿ */
#include "scene.h"

static void display(void)
{
  GLdouble projection[16]; /* ƩѴ¸ */
  int i;

  /* ǥӥ塼Ѵ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* ΰ֤ꤹʪΤ˰ư*/
  glTranslated(0.0, 0.0, -10.0);
  
  /* ȥåܡ뼰βžͿ */
  glMultMatrixd(trackballRotation());
  
  /* ΰ֤ꤹ */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
  /* ƥѴꤹ */
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  
  /* ƥɸ [-1,1] ϰϤ [0,1] ϰϤ˼ */
  glTranslated(0.5, 0.5, 0.5);
  glScaled(0.5, 0.5, 0.5);
  
  /* ߤƩѴФ */
  glGetDoublev(GL_PROJECTION_MATRIX, projection);

  /* ƩѴƥѴꤹ */
  glMultMatrixd(projection);

  /* ǥӥ塼Ѵ᤹ */
  glMatrixMode(GL_MODELVIEW);
  
  /* ǥץХåե򣰤ǥꥢ */
  glClearDepth(0.0);
  glClear(GL_DEPTH_BUFFER_BIT);

  /* ǥץХåեξõͤ򣱤᤹ */
  glClearDepth(1.0);

  /* ƥޥåԥ󥰤ȥƥɸμưͭˤ */
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_TEXTURE_GEN_R);
  glEnable(GL_TEXTURE_GEN_Q);
  
  /* եƥȤͭˤ */
  glEnable(GL_ALPHA_TEST);

  /* Polygon Offset ͭˤ */
  glEnable(GL_POLYGON_OFFSET_FILL);

  for (i = 0; i <= layer; ++i) {

    /* ǥץХåեǥץƥ˥ԡ */
    glCopyTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 0, 0, TEXWIDTH, TEXHEIGHT);

    /* ե졼ХåեȥǥץХåե򥯥ꥢ */
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
    /* 褹 */
    scene();
  }  
    
  /* Polygon Offset ̵ˤ */
  glDisable(GL_POLYGON_OFFSET_FILL);

  /* եƥȤ̵ˤ */
  glDisable(GL_ALPHA_TEST);

  /* ƥޥåԥ󥰤ȥƥɸμư̵ˤ */
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_TEXTURE_GEN_R);
  glDisable(GL_TEXTURE_GEN_Q);
  glDisable(GL_TEXTURE_2D);

  /* ֥Хåե */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* ɥγ̾¤ */
  if (w != TEXWIDTH || h != TEXHEIGHT) {
    if (w != TEXWIDTH) w = TEXWIDTH;
    if (h != TEXHEIGHT) h = TEXHEIGHT;
    glutReshapeWindow(w, h);
  }

  /* ȥåܡ뤹ϰ */
  trackballRegion(w, h);
  
  /* ɥΤӥ塼ݡȤˤ */
  glViewport(0, 0, w, h);
  
  /* ƩѴλ */
  glMatrixMode(GL_PROJECTION);
  
  /* ƩѴν */
  glLoadIdentity();
  gluPerspective(40.0, (GLdouble)w / (GLdouble)h, 3.0, 15.0);
}

static void idle(void)
{
  /* ̤ؤ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* ȥåܡ볫 */
      trackballStart(x, y);
      glutIdleFunc(idle);
      break;
    case GLUT_UP:
      /* ȥåܡ */
      trackballStop(x, y);
      glutIdleFunc(0);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* ȥåܡư */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  if (key >= '0' && key <= '9') {
    /* '0''9' Υ Depth Peeling Υ쥤䡼ѹ */
    layer = key - '0';
    glutPostRedisplay();
  }
  else {
    switch (key) {
    case 'q':
    case 'Q':
    case '\033':
      /* ESC  q  Q 򥿥פ齪λ */
      exit(0);
    default:
      break;
    }
  }
}

/*
** ᥤץ
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitWindowSize(TEXWIDTH, TEXHEIGHT);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
